﻿using Infragistics.Win.UltraWinCalcManager;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraCalcManagerTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet myDataSet = new DataSet("NumericDataSet");

            DataTable numericDataTable = new DataTable("NumericDataTable");

            numericDataTable.Columns.Add("Value1", typeof(double));
            numericDataTable.Columns.Add("Value2", typeof(double));
            numericDataTable.Columns.Add("Value3", typeof(double));

            numericDataTable.Rows.Add(1.5, 2.7, 3.2);
            myDataSet.Tables.Add(numericDataTable);

            BindingSource bindingSource = new BindingSource();
            bindingSource.DataSource = myDataSet.Tables["NumericDataTable"];

            this.ultraNumericEditor1.DataBindings.Add("Value", bindingSource, "Value1");
            this.ultraNumericEditor2.DataBindings.Add("Value", bindingSource, "Value2");
            this.ultraNumericEditor4.DataBindings.Add("Value", bindingSource, "Value3");

            this.setUpCalcManager();
        }


        private void setUpCalcManager()
        {
            CalcSettings cs1 =
              this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor1);
            cs1.PropertyName = "Value";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor1, cs1);

            CalcSettings cs2 =
              this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor2);
            cs2.PropertyName = "Value";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor2, cs2);

            CalcSettings cs3 = this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor3);
            cs3.PropertyName = "Value";
            cs3.Formula = "[//ultraNumericEditor1] + [//ultraNumericEditor2]";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor3, cs3);
            this.ultraNumericEditor3.ReadOnly = true;

            CalcSettings cs4 =
             this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor4);
            cs4.PropertyName = "Value";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor4, cs4);

            CalcSettings cs5 = this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor5);
            cs5.PropertyName = "Value";
            cs5.Formula = "[//ultraNumericEditor3] + [//ultraNumericEditor4]";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor5, cs5);
            this.ultraNumericEditor5.ReadOnly = true;

            CalcSettings cs6 = this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor6);
            cs6.PropertyName = "Value";
            cs6.Formula = "[//ultraNumericEditor3] + [//ultraNumericEditor5]";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor6, cs6);
            this.ultraNumericEditor6.ReadOnly = true;

            CalcSettings cs7 = this.ultraCalcManager1.GetCalcSettings(this.ultraNumericEditor7);   
            cs7.PropertyName = "Value";
            cs7.Formula = "[//ultraNumericEditor6]";
            this.ultraCalcManager1.SetCalcSettings(this.ultraNumericEditor7, cs7);
            this.ultraNumericEditor7.ReadOnly = true;
        }

        private void ultraNumericEditor6_ValueChanged(object sender, EventArgs e)
        {
            this.ultraCalcManager1.NotifyValueChanged(sender as Control);
        }
    }
}
